<?php

namespace Fastrack\Utilities;

use GuzzleHttp\Client;
use GuzzleHttp\HandlerStack;
use GuzzleLogMiddleware\Handler\LogLevelStrategy\StatusCodeStrategy;
use GuzzleLogMiddleware\Handler\MultiRecordArrayHandler;
use GuzzleLogMiddleware\LogMiddleware;
use Psr\Log\LoggerInterface;
use Psr\Log\LogLevel;
use SilverStripe\Core\Injector\Injector;

class Http
{

	public static function buildClient(bool $log): Client
	{
		if (!$log) {
			return new Client();
		}
		$strategy = new StatusCodeStrategy(LogLevel::INFO, LogLevel::CRITICAL);
		$strategy->setLevel(404, LogLevel::WARNING);
		$logger = Injector::inst()->get(LoggerInterface::class);
		$stack = HandlerStack::create();
		$stack->push(new LogMiddleware($logger, new MultiRecordArrayHandler($strategy, 99999)));
		return new Client(['handler' => $stack]);
	}
}
